'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactMoleculeDropdownList = require('@s-ui/react-molecule-dropdown-list');

var _reactMoleculeDropdownList2 = _interopRequireDefault(_reactMoleculeDropdownList);

var _reactAtomInput = require('@s-ui/react-atom-input');

var _reactAtomInput2 = _interopRequireDefault(_reactAtomInput);

var _withClearUI = require('../hoc/withClearUI');

var _withClearUI2 = _interopRequireDefault(_withClearUI);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AtomInputWithClearUI = (0, _withClearUI2.default)(_reactAtomInput2.default);

var MoleculeAutosuggestSingleSelection = function MoleculeAutosuggestSingleSelection(props) {
  /* eslint-disable react/prop-types */
  var _props$value = props.value,
      value = _props$value === undefined ? '' : _props$value,
      children = props.children,
      isOpen = props.isOpen,
      onToggle = props.onToggle,
      onChange = props.onChange,
      onInputKeyDown = props.onInputKeyDown,
      size = props.size,
      innerRefInput = props.innerRefInput,
      refMoleculeAutosuggest = props.refMoleculeAutosuggest,
      iconClear = props.iconClear,
      placeholder = props.placeholder;


  var handleSelection = function handleSelection(ev, _ref) {
    var value = _ref.value;

    onChange(ev, { value: value });
    onToggle(ev, { isOpen: false });
    refMoleculeAutosuggest.current.focus();
  };

  var handleChange = function handleChange(ev, _ref2) {
    var value = _ref2.value;

    onChange(ev, { value: value });
    onToggle(ev, { isOpen: true });
  };

  var handleClear = function handleClear() {
    onChange(null, { value: '' });
  };

  return _react2.default.createElement(
    _react.Fragment,
    null,
    _react2.default.createElement(AtomInputWithClearUI, {
      value: value,
      isVisibleClear: value,
      onClickClear: handleClear,
      onChange: handleChange,
      iconClear: iconClear,
      reference: innerRefInput,
      placeholder: placeholder,
      onKeyDown: onInputKeyDown
    }),
    value && _react2.default.createElement(
      _reactMoleculeDropdownList2.default,
      {
        isOpen: isOpen,
        size: size,
        visible: isOpen,
        onSelect: handleSelection,
        value: value,
        highlightQuery: value
      },
      children
    )
  );
};

MoleculeAutosuggestSingleSelection.displayName = 'MoleculeAutosuggestSingleSelection';

MoleculeAutosuggestSingleSelection.defaultProps = {
  value: ''
};

exports.default = MoleculeAutosuggestSingleSelection;